#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"
#include "SeSdk_String.h"

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void SE_CALLING_CONVENTION sub_process_static(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	void UpdatePositions( float *modpos_array, const SeSdkString &p_values );
	virtual void open();
	void ChooseProcess();
private:
//	void SendStringToGui( int p_msg_id, int p_length, unsigned char *p_data );
//	void send_index_to_gui(int what);
	static float StringToFloat(const SeSdkString &p_string);
	char *shape_ptr;
	void OnLookupTableChanged();
	float *input1_buffer;
	float *input2_buffer;
	float *input3_buffer;
	float *output1_buffer; 
	int *index_to_gui;
	int static_count;
	float* modpos_array;
	int last_count;
//	int truncate(float flt);
//	int Handle(void);
};

#endif
